import { Observable } from 'rxjs';
import { NgZone } from '@angular/core';
import { ReduxStateDefinition } from '../interfaces/redux-state-definition.interface';
import { ReduxActionWithPayload } from '../interfaces/redux-action-with-payload.interface';
export declare abstract class ReduxStateProvider<S = {}> {
    private zone;
    static instancesByName: {
        [stateName: string]: ReduxStateProvider;
    };
    readonly name: string;
    readonly stateDef: ReduxStateDefinition;
    protected selectorCache: {
        [selector: string]: Observable<{}>;
    };
    protected reducerMethodsByType: {
        [actionType: string]: Function[];
    };
    constructor(stateDefs: ReduxStateDefinition[], zone: NgZone);
    getInitialState(): S | Promise<S> | Observable<S>;
    select<T>(selector?: string): Observable<T>;
    getState(): Promise<S>;
    reduce<P>(state: S, action: ReduxActionWithPayload<P>): S;
    private getReducerMethods;
}
